package cn.com.infosec.jce.oscca;

import java.io.PrintStream;

public class SM3 {
   public static final int DIGEST_LENGTH = 32;
   private int[] H = new int[8];
   private final byte[] msg = new byte[64];
   private final boolean debug = false;
   private int currentPos;
   private long currentLen;

   public SM3() {
      this.reset();
   }

   private static final String toHexString(byte[] b) {
      StringBuffer var1;
      var1 = new StringBuffer.<init>();

      for(int var2 = 0; var2 < b.length; ++var2) {
         var1.append("0123456789ABCDEF".charAt(b[var2] >> 4 & 15));
         var1.append("0123456789ABCDEF".charAt(b[var2] & 15));
      }

      return var1.toString();
   }

   private final void putInt(byte[] b, int pos, int val) {
      b[pos] = (byte)(val >> 24);
      int var4 = pos + 1;
      b[var4] = (byte)(val >> 16);
      var4 = pos + 2;
      b[var4] = (byte)(val >> 8);
      var4 = pos + 3;
      b[var4] = (byte)val;
   }

   private final void perform() {
      int[] var1 = new int[68];
      int[] var2 = new int[64];
      int[] var3 = new int[8];

      int var4;
      int var6;
      for(var4 = 0; var4 < 16; ++var4) {
         byte[] var5;
         var1[var4] = ((var5 = this.msg)[var6 = var4 * 4] & 255) << 24 | (var5[var6 + 1] & 255) << 16 | (var5[var6 + 2] & 255) << 8 | var5[var6 + 3] & 255;
      }

      for(var4 = 16; var4 < 68; ++var4) {
         var1[var4] = this.p1(var1[var4 - 16] ^ var1[var4 - 9] ^ this.rotl(var1[var4 - 3], 15)) ^ this.rotl(var1[var4 - 13], 7) ^ var1[var4 - 6];
      }

      for(var4 = 0; var4 < 64; ++var4) {
         var2[var4] = var1[var4] ^ var1[var4 + 4];
      }

      for(var4 = 0; var4 < 8; ++var4) {
         var3[var4] = this.H[var4];
      }

      for(var4 = 0; var4 < 64; ++var4) {
         int var11;
         if (var4 < 16) {
            var11 = this.rotl(this.rotl(var3[7], 12) + var3[3] + this.rotl(2043430169, var4), 7);
         } else {
            var11 = this.rotl(this.rotl(var3[7], 12) + var3[3] + this.rotl(2055708042, var4), 7);
         }

         var6 = var11 ^ this.rotl(var3[7], 12);
         int var7;
         int var8;
         int var9;
         if (var4 < 16) {
            var7 = var3[7];
            var8 = var3[6];
            var9 = var3[5];
            var6 = this.FF_0_15(var7, var8, var9) + var3[4] + var6 + var2[var4];
         } else {
            var7 = var3[7];
            var8 = var3[6];
            var9 = var3[5];
            var6 = this.FF_16_63(var7, var8, var9) + var3[4] + var6 + var2[var4];
         }

         if (var4 < 16) {
            var7 = var3[3];
            var8 = var3[2];
            var9 = var3[1];
            var11 = this.GG_0_15(var7, var8, var9) + var3[0] + var11 + var1[var4];
         } else {
            var7 = var3[3];
            var8 = var3[2];
            var9 = var3[1];
            var11 = this.GG_16_63(var7, var8, var9) + var3[0] + var11 + var1[var4];
         }

         var3[4] = var3[5];
         var3[5] = this.rotl(var3[6], 9);
         var3[6] = var3[7];
         var3[7] = var6;
         var3[0] = var3[1];
         var3[1] = this.rotl(var3[2], 19);
         var3[2] = var3[3];
         var3[3] = this.p0(var11);
      }

      for(int var10 = 0; var10 < 8; ++var10) {
         int[] var10000 = this.H;
         var10000[var10] ^= var3[var10];
      }

   }

   private final int FF_0_15(int a, int b, int c) {
      return a ^ b ^ c;
   }

   private final int FF_16_63(int a, int b, int c) {
      return a & b | a & c | b & c;
   }

   private final int GG_0_15(int a, int b, int c) {
      return this.FF_0_15(a, b, c);
   }

   private final int GG_16_63(int a, int b, int c) {
      return a & b | ~a & c;
   }

   private final int rotl(int value, int bits) {
      return value << bits | value >>> -bits;
   }

   private final int p0(int x) {
      return x ^ this.rotl(x, 9) ^ this.rotl(x, 17);
   }

   private final int p1(int x) {
      return x ^ this.rotl(x, 15) ^ this.rotl(x, 23);
   }

   public static byte[] SM3Digest(byte[] msg) {
      SM3 var1;
      SM3 var10000 = var1 = new SM3;
      var10000.<init>();
      var10000.update(msg);
      byte[] var2 = new byte[32];
      var1.digest(var2);
      return var2;
   }

   public static void main(String[] args) {
      byte[] args1;
      byte[] var10000 = args1 = new byte[16];
      var10000[0] = 20;
      var10000[3] = 12;
      var10000[4] = -16;
      var10000[5] = -29;
      var10000[6] = 108;
      var10000[7] = -54;
      var10000[8] = 31;
      var10000[9] = -64;
      var10000[10] = 119;
      var10000[11] = -18;
      var10000[12] = -75;
      var10000[13] = 11;
      var10000[14] = 44;
      var10000[15] = 70;
      byte[] var1;
      var10000 = var1 = "abcdabcdabcdabcdabcdabcdabcdabcdabcdabcdabcdabcdabcdabcdabcdabcd".getBytes();
      byte[] var2 = new byte[32];
      byte var3 = 100;
      int var4 = var10000.length;
      long var5 = System.nanoTime();
      SM3 var12 = new SM3();
      var12.update(args1);
      var12.digest(var2);

      int args2;
      for(args2 = 0; args2 < 32; ++args2) {
         System.out.print(Integer.toHexString(var2[args2] & 255) + " ");
      }

      System.out.println();
      SM3 var7;
      var7 = new SM3.<init>();

      for(args2 = 0; args2 < var3; ++args2) {
         var7.update(var1);
      }

      var7.digest(var2);
      long var10 = System.nanoTime();
      PrintStream var13 = System.out;
      StringBuffer args3;
      StringBuffer var10001 = args3 = new StringBuffer;
      args3.<init>("SM3 Throughput = ");
      var13.println(var10001.append((double)(var4 * var3) * 1.0E9 / (double)(var10 - var5) / 1024.0 / 1024.0).append(" MB/sec").toString());
   }

   public final int getDigestLength() {
      return 32;
   }

   public final void reset() {
      int[] var10000 = this.H;
      var10000[7] = 1937774191;
      var10000[6] = 1226093241;
      var10000[5] = 388252375;
      var10000[4] = -628488704;
      var10000[3] = -1452330820;
      var10000[2] = 372324522;
      var10000[1] = -477237683;
      var10000[0] = -1325724082;

      byte[] var2;
      for(int var1 = 0; var1 < (var2 = this.msg).length; ++var1) {
         var2[var1] = 0;
      }

      this.currentPos = 0;
      this.currentLen = 0L;
   }

   public final void update(byte[] b, int off, int len) {
      for(int var4 = off; var4 < off + len; ++var4) {
         this.update(b[var4]);
      }

   }

   public final void update(byte[] b) {
      for(int var2 = 0; var2 < b.length; ++var2) {
         this.update(b[var2]);
      }

   }

   public final void update(byte b) {
      byte[] var2 = this.msg;
      int var3;
      int var4;
      int var10000 = var4 = (var3 = this.currentPos) + 1;
      this.currentPos = var4;
      var2[var3] = b;
      this.currentLen += 8L;
      if (var10000 == 64) {
         this.perform();
         this.currentPos = 0;
      }

   }

   public final void digest(byte[] out) {
      this.digest(out, 0);
   }

   public final void digest(byte[] out, int off) {
      long var3 = this.currentLen;
      this.update((byte)-128);

      while(this.currentPos != 56) {
         this.update((byte)0);
      }

      SM3 var10000 = this;
      SM3 var10001 = this;
      SM3 var10003 = this;
      SM3 var10004 = this;
      SM3 var10006 = this;
      SM3 var10007 = this;
      SM3 var10009 = this;
      SM3 var10010 = this;
      SM3 var10012 = this;
      SM3 var10013 = this;
      SM3 var10015 = this;
      SM3 var10016 = this;
      SM3 var10018 = this;
      SM3 var10019 = this;
      SM3 var10021 = this;
      this.update((byte)((int)(var3 >> 56)));
      this.update((byte)((int)(var3 >> 48)));
      this.update((byte)((int)(var3 >> 40)));
      this.update((byte)((int)(var3 >> 32)));
      this.update((byte)((int)(var3 >> 24)));
      this.update((byte)((int)(var3 >> 16)));
      this.update((byte)((int)(var3 >> 8)));
      this.update((byte)((int)var3));
      this.putInt(out, off, this.H[7]);
      int var5 = off + 4;
      var10019.putInt(out, var5, var10021.H[6]);
      var5 = off + 8;
      var10016.putInt(out, var5, var10018.H[5]);
      var5 = off + 12;
      var10013.putInt(out, var5, var10015.H[4]);
      var5 = off + 16;
      var10010.putInt(out, var5, var10012.H[3]);
      var5 = off + 20;
      var10007.putInt(out, var5, var10009.H[2]);
      var5 = off + 24;
      var10004.putInt(out, var5, var10006.H[1]);
      var5 = off + 28;
      var10001.putInt(out, var5, var10003.H[0]);
      var10000.reset();
   }
}
